local image_path;

local watermark;

local watermark_paint;

local image_frame_x;
local image_frame_y;
local image_frame_width;
local image_frame_height;

function setup()

	local layer_datas = viva_layer.get_data(viva_layer.this_layer())

	image_frame_x = layer_datas["image_frame_x"];
	image_frame_y = layer_datas["image_frame_y"];
	image_frame_width = layer_datas["image_frame_width"];
	image_frame_height = layer_datas["image_frame_height"];
	
	image_path = layer_datas["image_path"];

	watermark = h2d.create_image(image_path, 0)

    viva_layer.set_clickable(true)
    viva_layer.set_position(image_frame_x, image_frame_y)
    viva_layer.set_layer_size(image_frame_width, image_frame_height)

	watermark_paint = h2d_paint.image_pattern(image_frame_x, image_frame_y, image_frame_width, image_frame_height, 0, watermark, 1)

end

function draw()

	h2d.begin_frame_simple()
	
	h2d.begin_path()

	h2d.rect(image_frame_x,image_frame_y,image_frame_width,image_frame_height)

	h2d.fill_paint(watermark_paint)

	h2d.fill()

	h2d.end_frame()
end

function hittest(point_x, point_y)
    local result = false
    if point_x >= image_frame_x then
        if point_x <= image_frame_x + image_frame_width then
            if point_y >= image_frame_y then
                if point_y <= image_frame_y + image_frame_height then
                    result = true
                end
            end
        end
    end
    return result
end

function clenup()

	h2d.delete_image(watermark)

end














