
local lyric_time = {};
local lyric_text = {};

local lyric_frame_x;
local lyric_frame_y;
local lyric_frame_width;
local lyric_frame_height;
local lyric_shadow_blur;
local lyric_shadow_alpha;
local lyric_text_size;
local temp_text;
local image;

function get_sorted_index(k, arr)

	for i = 1, #arr do
		if tonumber(k) <= arr[i] then
			return i;
		end
	end

	return #arr + 1
end


function setup()

	local layer_datas = viva_layer.get_data(viva_layer.this_layer())
	image = 0
	for k, v in pairs(layer_datas) do
	
		if k == "lyric_frame_x" then
			lyric_frame_x = v;
		elseif k == "lyric_frame_y" then
			lyric_frame_y = v;
		elseif k == "lyric_frame_width" then
			lyric_frame_width = v;
		elseif k == "lyric_frame_height" then
			lyric_frame_height = v;
        elseif k == "lyric_shadow_blur" then
            lyric_shadow_blur = v;
        elseif k == "lyric_shadow_alpha" then
            lyric_shadow_alpha = v;
		else
			local idx = get_sorted_index(k, lyric_time)
			table.insert(lyric_time, idx, tonumber(k))
			table.insert(lyric_text, idx, v)
		end
		
	end
end

function get_lyric_index(frame_index)
	
	local forward_text = ""
    local current_text = ""

	for index = 1,#lyric_time do
	 	if lyric_time[index] <  frame_index then
			forward_text = lyric_text[index];
	 	elseif frame_index == lyric_time[index] then
			current_text = lyric_text[index];
			break;
	 	else 
			current_text = forward_text
			break;
	 	end
	
	end
	
	return current_text;
end

function draw()

    local index =  viva.frame_index()
    local show_text = get_lyric_index(index)

    h2d.begin_frame_simple()
    h2d.fill_color(h2d_color.rgba_f(1.0,1.0,1.0,1.0))
    h2d.font_face("font")
    h2d.text_align(H2D_ALIGN.H2D_ALIGN_CENTER)
    h2d.text_drop_shadow(lyric_shadow_blur,-1,1,h2d_color.rgba_f(0,0,0,lyric_shadow_alpha))

    if temp_text ~= show_text then
       lyric_text_size = h2d.text_box_formatter(lyric_frame_x, lyric_frame_y, lyric_frame_width, lyric_frame_height, show_text)
       if image ~= 0 then
          h2d.delete_image(image)
       end
       h2d.font_size(lyric_text_size)
       image = h2d.text_box_image(lyric_frame_x, lyric_frame_y, lyric_frame_width, lyric_frame_height, show_text)
    end

    h2d.draw_text_box_image(lyric_frame_x, lyric_frame_y, lyric_frame_width,lyric_frame_height,image)
    h2d.end_frame()

    temp_text = show_text
end


function clenup()

    if image ~= 0 then
       h2d.delete_image(image)
    end
    lyric_time = nil
    lyric_text = nil

end
